function [ subp ] = update_weights( base_weight, subp, density, radius)
% Author: Asad Mohammadi
% Email : asadmoh1985@gmail.com
% -----------
% References:
% -----------
%  Mohammadi, A., Omidvar, M. and Li, X. (2012), "Reference Point Based Multi-objective Optimization Through Decomposition", 
%  in Proceedings of Congress of Evolutionary Computation (CEC 2012), IEEE,  p.1150 - 1157.
% --------
% License:
% --------
% This program is to be used under the terms of the GNU General Public License 
% (http://www.gnu.org/copyleft/gpl.html).
% Author: Asad Mohammadi
% Email : asadmoh1985@gmail.com
% Copyright notice: (c) 2014 Asad Mohammadi
% In UPDATE_WEIGHTS, weight vectors are upated based on the base weight vector, 
% population size and the radius which detemines the size of preferred region Summary of this function goes here
 

    noObj = length(base_weight);

    weights = zeros(density, noObj);
    initweights = length(subp) < density;
    i = 1;
    while (i <= density)
        weights(i, :) = (rand(1, noObj) - 0.5) * radius;
        weights(i, :) =  base_weight + weights(i, :);
        weights(i, :) = weights(i, :) / norm(weights(i, :), 1);
        if(isempty(find(weights(i, :) < 0, 1)))
            i = i + 1;
        end
    end
    

    for i=1:density
        if(initweights)
            p=struct('weight',[],'neighbour',[],'optimal', Inf, 'optpoint',[], 'curpoint', []);
            p.weight = weights(i, :)';
            subp = [subp p];
        else
            subp(i).weight = weights(i, :)';
        end 
    end

    if(initweights)
        leng=length(subp);
        distanceMatrix=zeros(leng, leng);
        niche=leng;
        for i=1:leng
            for j=i+1:leng
                A=subp(i).weight;
                B=subp(j).weight;
                distanceMatrix(i,j)=(A-B)'*(A-B);
                distanceMatrix(j,i)=distanceMatrix(i,j);
            end
            [s,sindex]=sort(distanceMatrix(i,:));
            subp(i).neighbour=sindex(1:niche)';
        end
    end
    
end

